<div
  class="full-width flex-fixed-size"
  [attr.data-test-element-id]="'execution-step'"
  [attr.data-test-execution-step-id]="step.id"
>
  <div
    #dropFileZone
    class="flex-row full-width step-list-element"
    [ngStyle]="getExecutionStepLeftBorderColor(step.executionStatus)"
    sqtmCoreAttachmentDropZone
    (filesDropEvent)="addAttachment($event)"
    (filesDragEnterEvent)="handleAttachmentEnter()"
    (filesDragLeaveEvent)="handleAttachmentLeave()"
  >
    <div
      class="flex-column index-column flex-fixed-size"
      [attr.data-test-element-id]="'index-execution-step'"
      [ngStyle]="getExecutionStepBackgroundColor(step.executionStatus)"
    >
      <div class="index-typography">{{ this.step.order + 1 }}</div>
    </div>
    <div class="full-width m-l-10 m-b-10">
      <sqtm-app-execution-step-header-toolbar
        [step]="step"
        [execution]="execution"
        [disabledExecutionStatus]="disabledExecutionStatus"
        [permissions]="permissions"
        [milestonesAllowModification]="milestonesAllowModification"
        [bugtracker]="bugtracker"
        [authenticated]="authenticated"
        [issuesNb]="issues.length"
        (refreshData)="this.refresh()"
        (stepToggled)="removeCommentFieldForceDisplay()"
        (editCommentField)="this.addComment()"
        (addAttachment)="this.addAttachment($event)"
      >
      </sqtm-app-execution-step-header-toolbar>

      <div
        class="full-width m-t-5"
        [ngClass]="getExecutionStepGridClass()"
        #grid
        [class.collapsed]="!step.extended"
      >
        <div
          #header
          class="header-action"
          [class.header-collapsed]="!step.extended"
        >
          @if (step.extended) {
            <span class="header-color">
              {{
                (execution.kind === 'GHERKIN'
                  ? 'sqtm-core.entity.test-step.script'
                  : 'sqtm-core.entity.test-step.action.singular'
                ) | translate
              }}
            </span>
            <div
              class="action-resize-handler"
              sqtmCoreResizable
              (resize)="handleResize($event)"
            ></div>
          } @else {
            <div class="flex-fixed-size">
              <span class="header-color">
                {{
                  (execution.kind === 'GHERKIN'
                    ? 'sqtm-core.entity.test-step.script'
                    : 'sqtm-core.entity.test-step.action.singular'
                  ) | translate
                }}
                :&nbsp;
              </span>
            </div>
            <div
              class="full-height full-width header-collapsed-rich-text m-l-5 m-r-5"
              [innerHTML]="action | safeRichContent"
            ></div>
          }
        </div>
        @if (execution.kind === 'STANDARD') {
          <div class="header-result" [class.header-collapsed]="!step.extended">
            @if (step.extended) {
              <span class="header-color">{{
                'sqtm-core.entity.test-step.expected-result.label' | translate
              }}</span>
            } @else {
              <div class="flex-fixed-size">
                <span class="header-color"
                  >{{
                    'sqtm-core.entity.test-step.expected-result.label'
                      | translate
                  }}
                  :</span
                >&nbsp;
              </div>
              <div
                class="full-height full-width header-collapsed-rich-text m-l-5"
                [innerHTML]="expectedResult | safeRichContent"
              ></div>
            }
          </div>
        }
        @if (step.extended) {
          <div class="action block-border" style="overflow: hidden">
            <div
              class="m-l-10"
              [attr.data-test-element-id]="'execution-step-action'"
              [innerHTML]="action | safeRichContent"
            ></div>
          </div>
        }
        @if (step.extended && execution.kind === 'STANDARD') {
          <div class="result block-border" style="overflow: hidden">
            <div
              class="m-l-10"
              [attr.data-test-element-id]="'execution-step-expected-result'"
              [innerHTML]="expectedResult | safeRichContent"
            ></div>
          </div>
        }
      </div>

      @if (
        (step.extended &&
          execution.kind === 'STANDARD' &&
          executionStepCustomFields.length > 0) ||
        (step.extended && step.denormalizedCustomFieldValues.length > 0)
      ) {
        <div style="overflow: hidden">
          <div class="m-t-15 m-b-5 header-color">
            {{ 'sqtm-core.entity.custom-field.label.plural' | translate }}
          </div>
          <div class="custom-fields m-t-10 block-border">
            @for (
              dfv of step.denormalizedCustomFieldValues;
              track dfv;
              let index = $index
            ) {
              <div class="flex-row overflow-hidden m-l-10">
                <label
                  nz-tooltip
                  [nzTooltipTitle]="
                    'sqtm-core.campaign-workspace.execution-page.dnz-cuf.test-step.tooltip'
                      | translate
                  "
                  [attr.data-test-element-id]="'execution-dnz-label-' + index"
                  class="txt-ellipsis"
                  >{{ dfv.label }}
                </label>
                <label class="m-l-3">*</label>
              </div>
              <div>
                <sqtm-app-denormalized-custom-field
                  [denormalizedFieldValue]="dfv"
                  [attr.data-test-element-id]="'execution-dnz-value-' + index"
                >
                </sqtm-app-denormalized-custom-field>
              </div>
            }
            @for (customField of executionStepCustomFields; track customField) {
              <sqtm-core-label
                [text]="customField.label"
                class="m-l-10"
              ></sqtm-core-label>
              <div>
                <sqtm-core-custom-field-widget
                  [targetOnUpload]="{
                    entityId: step.id,
                    attachmentListId: step.attachmentList.id,
                    holderType: AttachmentHolderType.EXECUTION_STEP
                  }"
                  [customField]="customField"
                  [value]="getCfvValue(customField)"
                  [editable]="canEdit()"
                  (confirmEvent)="updateCustomFieldValue(customField, $event)"
                >
                </sqtm-core-custom-field-widget>
              </div>
            }
          </div>
        </div>
      }
      @if (
        (this.forceCommentFieldDisplay$ | async) ||
        (step.comment && step.extended)
      ) {
        <div style="overflow: hidden">
          <div class="m-t-15 m-b-5 header-color">
            {{ 'sqtm-core.entity.execution.comment' | translate }}
          </div>
          <div class="m-t-10 block-border">
            <sqtm-core-editable-rich-text
              #commentField
              [value]="step.comment"
              [focus]="true"
              [editable]="canEdit()"
              [targetOnUpload]="{
                entityId: step.id,
                attachmentListId: step.attachmentList.id,
                holderType: AttachmentHolderType.EXECUTION_STEP
              }"
              [attr.data-test-field-id]="'comment'"
              (confirmEvent)="changeComment($event)"
              (cancelEvent)="this.removeCommentFieldForceDisplay()"
            >
            </sqtm-core-editable-rich-text>
          </div>
        </div>
      }

      @if (step.extended && step.attachmentList.attachments.ids.length > 0) {
        <div>
          <div class="m-t-15 m-b-5 header-color">
            {{ 'sqtm-core.entity.attachment.label.long.plural' | translate }}
          </div>
          <div class="block-border m-t-10 p-l-10">
            <sqtm-core-attachment-list-compact
              [attachments]="getAttachments(step)"
              [attachmentListId]="step.attachmentList.id"
              [canAttach]="canEdit()"
              (deleteAttachmentEvent)="deleteAttachment($event, step.id)"
              (confirmDeleteAttachmentEvent)="
                confirmDeleteAttachmentEvent(
                  $event,
                  step.id,
                  step.attachmentList.id
                )
              "
              (cancelDeleteAttachmentEvent)="
                cancelDeleteAttachmentEvent($event, step.id)
              "
              (removeRejectedAttachmentEvent)="
                removeRejectedAttachment($event, step.id)
              "
            >
            </sqtm-core-attachment-list-compact>
          </div>
        </div>
      }

      @if (step.extended && issues.length > 0) {
        <div>
          <div class="m-t-15 m-b-5 header-color">
            {{ 'sqtm-core.entity.issue.label.plural' | translate }}
          </div>
          <div class="block-border m-t-10 p-l-10">
            <sqtm-core-issue-list-compact
              [issues]="issues"
              [canDelete]="permissions.canExecute"
              (issuesDeleted)="deleteIssue($event)"
            ></sqtm-core-issue-list-compact>
          </div>
        </div>
      }
    </div>
  </div>
</div>
